From: "Ian Delaney" <idella4@gentoo.org>
To: gentoo-commits@lists.gentoo.org
Subject: [gentoo-commits] repo/gentoo:master commit in: dev-lisp/sbcl/
Date: Sun, 7 Feb 2016 21:47:31 +0000 (UTC) [thread overview]
Message-ID: <1454871510.944c46edbf96fffc7d9151853ba361589d6a13d0.idella4@gentoo> (raw)
commit: 944c46edbf96fffc7d9151853ba361589d6a13d0
Author: Nicholas Vinson <nvinson234 <AT> gmail <DOT> com>
AuthorDate: Sun Feb 7 18:40:05 2016 +0000
Commit: Ian Delaney <idella4 <AT> gentoo <DOT> org>
CommitDate: Sun Feb 7 18:58:30 2016 +0000
URL: https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=944c46ed
dev-lisp/sbcl: Fix for bug #572478
Package-Manager: portage-2.2.27
dev-lisp/sbcl/sbcl-1.1.18-r1.ebuild | 216 ++++++++++++++++++++++++++++++++++++
1 file changed, 216 insertions(+)
diff --git a/dev-lisp/sbcl/sbcl-1.1.18-r1.ebuild b/dev-lisp/sbcl/sbcl-1.1.18-r1.ebuild
new file mode 100644
index 0000000..cb391da
--- /dev/null
+++ b/dev-lisp/sbcl/sbcl-1.1.18-r1.ebuild
@@ -0,0 +1,216 @@
+# Copyright 1999-2016 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+EAPI=5
+inherit multilib eutils flag-o-matic pax-utils
+
+#same order as http://www.sbcl.org/platform-table.html
+BV_X86=1.0.58
+BV_AMD64=1.1.18
+BV_PPC=1.0.28
+BV_SPARC=1.0.28
+BV_ALPHA=1.0.28
+
+DESCRIPTION="Steel Bank Common Lisp (SBCL) is an implementation of ANSI Common Lisp"
+HOMEPAGE="http://sbcl.sourceforge.net/"
+SRC_URI="mirror://sourceforge/sbcl/${P}-source.tar.bz2
+ x86? ( mirror://sourceforge/sbcl/${PN}-${BV_X86}-x86-linux-binary.tar.bz2 )
+ amd64? ( mirror://sourceforge/sbcl/${PN}-${BV_AMD64}-x86-64-linux-binary.tar.bz2 )
+ ppc? ( mirror://sourceforge/sbcl/${PN}-${BV_PPC}-powerpc-linux-binary.tar.bz2 )
+ sparc? ( mirror://sourceforge/sbcl/${PN}-${BV_SPARC}-sparc-linux-binary.tar.bz2 )
+ alpha? ( mirror://sourceforge/sbcl/${PN}-${BV_ALPHA}-alpha-linux-binary.tar.bz2 )"
+
+LICENSE="MIT"
+SLOT="0/${PV}"
+KEYWORDS="~amd64 ~ppc ~sparc ~x86"
+IUSE="debug doc source +threads +unicode pax_kernel zlib"
+
+CDEPEND="=dev-lisp/asdf-3.0*:="
+DEPEND="${CDEPEND}
+ doc? ( sys-apps/texinfo >=media-gfx/graphviz-2.26.0 )
+ pax_kernel? ( sys-apps/paxctl sys-apps/elfix )"
+RDEPEND="${CDEPEND}
+ elibc_glibc? ( >=sys-libs/glibc-2.3 || ( >=sys-libs/glibc-2.6 ) )"
+
+# Disable warnings about executable stacks, as this won't be fixed soon by upstream
+QA_EXECSTACK="usr/bin/sbcl"
+
+CONFIG="${S}/customize-target-features.lisp"
+ENVD="${T}/50sbcl"
+
+# Prevent ASDF from using the system libraries
+CL_SOURCE_REGISTRY="(:source-registry :ignore-inherited-configuration)"
+ASDF_OUTPUT_TRANSLATIONS="(:output-translations :ignore-inherited-configuration)"
+
+usep() {
+ use ${1} && echo "true" || echo "false"
+}
+
+sbcl_feature() {
+ echo "$( [[ ${1} == "true" ]] && echo "(enable ${2})" || echo "(disable ${2})")" >> "${CONFIG}"
+}
+
+sbcl_apply_features() {
+ sed 's/^X//' > "${CONFIG}" <<-'EOF'
+ (lambda (list)
+ X (flet ((enable (x) (pushnew x list))
+ X (disable (x) (setf list (remove x list))))
+ EOF
+ if use x86 || use amd64; then
+ sbcl_feature "$(usep threads)" ":sb-thread"
+ fi
+ sbcl_feature "true" ":sb-ldb"
+ sbcl_feature "false" ":sb-test"
+ sbcl_feature "$(usep unicode)" ":sb-unicode"
+ sbcl_feature "$(usep zlib)" ":sb-core-compression"
+ sbcl_feature "$(usep debug)" ":sb-xref-for-internals"
+ sed 's/^X//' >> "${CONFIG}" <<-'EOF'
+ X )
+ X list)
+ EOF
+ cat "${CONFIG}"
+}
+
+src_unpack() {
+ unpack ${A}
+ mv sbcl-*-linux sbcl-binary || die
+ cd "${S}"
+}
+
+src_prepare() {
+ epatch "${FILESDIR}"/gentoo-fix_install_man.patch
+ epatch "${FILESDIR}"/gentoo-fix_linux-os-c.patch
+ # bug #468482
+ epatch "${FILESDIR}"/concurrency-test.patch
+ # bug #486552
+ epatch "${FILESDIR}"/bsd-sockets-test.patch
+
+ # To make the hardened compiler NOT compile with -fPIE -pie
+ if gcc-specs-pie ; then
+ einfo "Disabling PIE..."
+ epatch "${FILESDIR}"/${PN}-1.1.17-gentoo-fix_nopie_for_hardened_toolchain.patch
+ fi
+
+ # bug #526194
+ sed -e "s@CFLAGS =@CFLAGS = ${CFLAGS}@" \
+ -e "s@LINKFLAGS =@LINKFLAGS = ${LDFLAGS}@" \
+ -i src/runtime/GNUmakefile || die
+
+ cp /usr/share/common-lisp/source/asdf/build/asdf.lisp contrib/asdf/ || die
+
+ use source && sed 's%"$(BUILD_ROOT)%$(MODULE).lisp "$(BUILD_ROOT)%' -i contrib/vanilla-module.mk
+
+ # Some shells(such as dash) don't have "time" as builtin
+ # and we don't want to DEPEND on sys-process/time
+ sed "s,^time ,," -i make.sh || die
+ sed "s,/lib,/$(get_libdir),g" -i install.sh || die
+ # #define SBCL_HOME ...
+ sed "s,/usr/local/lib,/usr/$(get_libdir),g" -i src/runtime/runtime.c || die
+
+ find . -type f -name .cvsignore -delete
+
+ # bug #572478
+ sed "s%(sb-posix:rmdir #-win32 \"/\"%(sb-posix:rmdir #-win32 \
+ \"$(PORTAGE_BUILDDIR)\"%" -i contrib/sb-posix/posix-tests.lisp
+}
+
+src_configure() {
+ # customizing SBCL version as per
+ # http://sbcl.cvs.sourceforge.net/sbcl/sbcl/doc/PACKAGING-SBCL.txt?view=markup
+ echo -e ";;; Auto-generated by Gentoo\n\"gentoo-${PR}\"" > branch-version.lisp-expr
+
+ # applying customizations
+ sbcl_apply_features
+}
+
+src_compile() {
+ local bindir="${WORKDIR}"/sbcl-binary
+
+ strip-unsupported-flags ; filter-flags -fomit-frame-pointer
+
+ if host-is-pax ; then
+ # To disable PaX on hardened systems
+ pax-mark -mr "${bindir}"/src/runtime/sbcl
+
+ # Hack to disable PaX on second GENESIS stage
+ sed -i -e '/^echo \/\/doing warm init - compilation phase$/a\paxmark.sh -mr \.\/src\/runtime\/sbcl' \
+ "${S}"/make-target-2.sh || die "Cannot disable PaX on second GENESIS runtime"
+ fi
+
+ # clear the environment to get rid of non-ASCII strings, see bug 174702
+ # set HOME for paludis
+ env - HOME="${T}" \
+ CC="$(tc-getCC)" AS="$(tc-getAS)" LD="$(tc-getLD)" \
+ CPPFLAGS="${CPPFLAGS}" CFLAGS="${CFLAGS}" ASFLAGS="${ASFLAGS}" LDFLAGS="${LDFLAGS}" \
+ GNUMAKE=make ./make.sh \
+ "sh ${bindir}/run-sbcl.sh --no-sysinit --no-userinit --disable-debugger" \
+ || die "make failed"
+
+ # need to set HOME because libpango(used by graphviz) complains about it
+ if use doc; then
+ env - HOME="${T}" \
+ CL_SOURCE_REGISTRY="(:source-registry :ignore-inherited-configuration)" \
+ ASDF_OUTPUT_TRANSLATIONS="(:output-translations :ignore-inherited-configuration)" \
+ make -C doc/manual info html || die "Cannot build manual"
+ env - HOME="${T}" \
+ CL_SOURCE_REGISTRY="(:source-registry :ignore-inherited-configuration)" \
+ ASDF_OUTPUT_TRANSLATIONS="(:output-translations :ignore-inherited-configuration)" \
+ make -C doc/internals info html || die "Cannot build internal docs"
+ fi
+}
+
+src_test() {
+ ewarn "Unfortunately, it is known that some tests fail eg."
+ ewarn "run-program.impure.lisp. This is an issue of the upstream's"
+ ewarn "development and not of Gentoo's side. Please, before filing"
+ ewarn "any bug(s) search for older submissions. Thank you."
+ time ( cd tests && sh run-tests.sh )
+}
+
+src_install() {
+ # install system-wide initfile
+ dodir /etc/
+ sed 's/^X//' > "${D}"/etc/sbclrc <<-EOF
+ ;;; The following is required if you want source location functions to
+ ;;; work in SLIME, for example.
+ X
+ (setf (logical-pathname-translations "SYS")
+ X '(("SYS:SRC;**;*.*.*" #p"/usr/$(get_libdir)/sbcl/src/**/*.*")
+ X ("SYS:CONTRIB;**;*.*.*" #p"/usr/$(get_libdir)/sbcl/**/*.*")))
+ X
+ ;;; Setup ASDF2
+ (load "/etc/common-lisp/gentoo-init.lisp")
+ EOF
+
+ # Install documentation
+ unset SBCL_HOME
+ INSTALL_ROOT="${D}/usr" LIB_DIR="/usr/$(get_libdir)" DOC_DIR="${D}/usr/share/doc/${PF}" \
+ sh install.sh || die "install.sh failed"
+
+ # rm empty directories lest paludis complain about this
+ find "${D}" -empty -type d -exec rmdir -v {} +
+
+ if use doc; then
+ dohtml -r doc/manual/
+ doinfo doc/manual/*.info*
+ dohtml -r doc/internals/sbcl-internals
+ doinfo doc/internals/sbcl-internals.info
+ docinto internals-notes && dodoc doc/internals-notes/*
+ else
+ rm -Rv "${D}/usr/share/doc/${PF}" || die
+ fi
+
+ dodoc BUGS CREDITS INSTALL NEWS OPTIMIZATIONS PRINCIPLES README TLA TODO
+
+ # install the SBCL source
+ if use source; then
+ ./clean.sh
+ cp -av src "${D}/usr/$(get_libdir)/sbcl/" || die
+ fi
+
+ # necessary for running newly-saved images
+ echo "SBCL_HOME=/usr/$(get_libdir)/${PN}" > "${ENVD}"
+ echo "SBCL_SOURCE_ROOT=/usr/$(get_libdir)/${PN}/src" >> "${ENVD}"
+ doenvd "${ENVD}"
+}
next reply other threads:[~2016-02-07 21:47 UTC|newest]
Thread overview: 186+ messages / expand[flat|nested] mbox.gz Atom feed top
2016-02-07 21:47 Ian Delaney [this message]
-- strict thread matches above, loose matches on Subject: below --
2024-12-06 9:15 [gentoo-commits] repo/gentoo:master commit in: dev-lisp/sbcl/ Andrey Grozin
2024-11-10 15:30 Sam James
2024-11-10 13:45 Andrey Grozin
2024-11-02 9:43 Arthur Zamarin
2024-11-02 1:42 Sam James
2024-11-01 20:42 Sam James
2024-11-01 7:13 Sam James
2024-11-01 6:00 Andrey Grozin
2024-11-01 5:54 Andrey Grozin
2024-10-03 13:02 Andrey Grozin
2024-10-03 13:00 Andrey Grozin
2024-09-01 14:58 Andrey Grozin
2024-09-01 14:56 Andrey Grozin
2024-08-01 3:46 Eli Schwartz
2024-07-29 11:16 Andrey Grozin
2024-07-29 11:12 Andrey Grozin
2024-07-12 5:55 Eli Schwartz
2024-07-12 5:55 Eli Schwartz
2024-06-30 17:21 Andrey Grozin
2024-06-30 17:19 Andrey Grozin
2024-05-30 13:52 Andrey Grozin
2024-05-13 12:06 Arthur Zamarin
2024-05-12 22:41 Sam James
2024-05-12 22:41 Sam James
2024-05-12 13:57 Andrey Grozin
2024-05-12 13:55 Andrey Grozin
2024-04-03 15:41 Andrey Grozin
2024-03-03 16:31 Andrey Grozin
2024-02-12 4:53 Andrey Grozin
2024-02-09 15:09 Andrey Grozin
2024-02-09 15:07 Andrey Grozin
2023-12-31 10:59 Andrey Grozin
2023-12-31 10:57 Andrey Grozin
2023-11-30 5:00 Andrey Grozin
2023-11-30 4:59 Andrey Grozin
2023-11-17 11:29 Andrey Grozin
2023-11-17 11:27 Andrey Grozin
2023-10-10 10:21 Andrey Grozin
2023-08-29 12:39 Andrey Grozin
2023-08-29 11:21 Andrey Grozin
2023-08-06 11:51 Sam James
2023-08-06 11:17 Andrey Grozin
2023-08-05 4:17 Sam James
2023-07-21 12:49 Sam James
2023-07-21 11:43 Arthur Zamarin
2023-07-21 11:16 Arthur Zamarin
2023-07-21 9:10 Andrey Grozin
2023-06-16 15:01 Andrey Grozin
2023-05-04 15:53 Andrey Grozin
2023-05-04 15:51 Andrey Grozin
2023-04-29 6:44 Sam James
2023-04-12 12:03 Andrey Grozin
2023-04-12 12:02 Andrey Grozin
2023-03-27 10:24 Andrey Grozin
2023-03-27 10:17 Andrey Grozin
2023-01-15 15:09 Andrey Grozin
2023-01-15 15:08 Andrey Grozin
2023-01-15 10:59 Andrey Grozin
2023-01-15 10:56 Andrey Grozin
2022-11-30 15:32 Andrey Grozin
2022-11-23 14:12 Jakov Smolić
2022-11-13 11:49 Matthew Smith
2022-11-11 20:27 Sam James
2022-11-11 7:04 Sam James
2022-11-11 7:04 Sam James
2022-11-01 9:32 Andrey Grozin
2022-11-01 9:30 Andrey Grozin
2022-10-01 10:22 Andrey Grozin
2022-09-22 4:09 Sam James
2022-09-02 15:50 Andrey Grozin
2022-07-14 12:36 Andrey Grozin
2022-06-04 13:43 Andrey Grozin
2022-06-04 13:41 Andrey Grozin
2022-05-04 8:48 Andrey Grozin
2022-05-04 8:46 Andrey Grozin
2022-03-30 15:46 Andrey Grozin
2022-03-07 3:22 Andrey Grozin
2022-03-07 3:20 Andrey Grozin
2022-02-28 4:55 Sam James
2022-02-17 11:15 Jakov Smolić
2022-02-17 11:00 Jakov Smolić
2022-02-02 13:01 Andrey Grozin
2022-02-02 9:47 Sam James
2022-02-02 9:47 Sam James
2022-01-31 15:31 Andrey Grozin
2022-01-18 23:35 Sam James
2022-01-18 23:27 Sam James
2022-01-02 14:15 Andrey Grozin
2022-01-02 14:13 Andrey Grozin
2021-12-12 5:22 Andrey Grozin
2021-11-04 10:49 Andrey Grozin
2021-11-04 10:47 Andrey Grozin
2021-09-04 11:49 Andrey Grozin
2021-08-09 16:51 Andrey Grozin
2021-07-19 3:12 Andrey Grozin
2021-07-19 3:10 Andrey Grozin
2021-06-22 10:27 Ulrich Müller
2021-06-02 7:56 Andrey Grozin
2021-04-30 9:14 Andrey Grozin
2021-04-18 13:44 Andrey Grozin
2021-03-31 9:55 Andrey Grozin
2021-03-03 6:30 Andrey Grozin
2021-02-08 6:16 Andrey Grozin
2021-01-28 5:24 Andrey Grozin
2021-01-07 8:20 Fabian Groffen
2021-01-06 19:34 Fabian Groffen
2020-12-10 6:03 Andrey Grozin
2020-12-10 5:07 Andrey Grozin
2020-10-30 15:40 Andrey Grozin
2020-10-06 16:41 Andrey Grozin
2020-09-09 15:32 Andrey Grozin
2020-08-05 12:20 Andrey Grozin
2020-04-28 16:55 Andrey Grozin
2020-01-05 15:55 Andrey Grozin
2019-11-20 14:52 Andrey Grozin
2019-11-20 14:39 Andrey Grozin
2019-10-01 13:23 Andrey Grozin
2019-09-24 10:23 Andrey Grozin
2019-06-01 14:58 Jonas Stein
2019-03-12 18:29 Andrey Grozin
2019-01-01 5:06 Andrey Grozin
2018-12-14 22:48 Sergei Trofimovich
2018-12-14 2:13 Thomas Deutschmann
2018-11-23 14:10 Andrey Grozin
2018-10-01 16:02 Andrey Grozin
2018-09-05 15:18 Andrey Grozin
2018-08-04 18:34 José María Alonso
2018-08-04 11:17 Patrick Lauer
2018-07-02 19:33 José María Alonso
2018-05-29 20:00 José María Alonso
2018-05-01 14:37 José María Alonso
2018-05-01 14:35 José María Alonso
2018-04-08 19:05 Aaron Bauman
2018-04-01 20:53 José María Alonso
2018-04-01 13:47 Sergei Trofimovich
2018-03-10 12:23 Pacho Ramos
2018-02-28 17:15 José María Alonso
2018-02-11 10:36 Michał Górny
2018-01-31 22:04 José María Alonso
2017-12-31 13:24 José María Alonso
2017-11-30 22:07 José María Alonso
2017-11-13 22:15 José María Alonso
2017-10-31 19:29 José María Alonso
2017-10-31 19:08 José María Alonso
2017-10-11 13:27 José María Alonso
2017-09-02 14:58 José María Alonso
2017-08-23 21:07 José María Alonso
2017-08-07 20:54 Amy Liffey
2017-08-01 13:18 Andrey Grozin
2017-07-02 17:26 Alexis Ballier
2017-06-01 10:03 José María Alonso
2017-04-29 17:28 José María Alonso
2017-02-14 22:37 José María Alonso
2017-02-08 18:03 José María Alonso
2017-01-22 17:34 Andrey Grozin
2017-01-22 17:32 Andrey Grozin
2017-01-22 16:46 Andrey Grozin
2017-01-12 16:27 Andrey Grozin
2016-12-29 10:05 Agostino Sarubbo
2016-11-15 11:30 Andrey Grozin
2016-09-11 17:17 Andrey Grozin
2016-09-11 16:47 Andrey Grozin
2016-08-04 6:48 Andrey Grozin
2016-06-19 2:16 Göktürk Yüksek
2016-06-15 5:43 Andrey Grozin
2016-05-02 16:18 Andrey Grozin
2016-04-03 8:32 Andrey Grozin
2016-03-19 23:45 Ian Delaney
2016-03-19 23:45 Ian Delaney
2016-03-18 11:20 Andrey Grozin
2016-02-24 17:07 Andrey Grozin
2016-02-24 17:05 Andrey Grozin
2016-02-13 15:13 Ulrich Müller
2016-02-13 15:13 Ulrich Müller
2016-02-13 14:38 Ulrich Müller
2016-02-07 21:47 Ian Delaney
2015-12-12 6:42 Andrey Grozin
2015-11-04 4:55 Andrey Grozin
2015-10-27 19:01 Magnus Granberg
2015-10-12 10:45 Andrey Grozin
2015-10-10 4:56 Andrey Grozin
2015-10-08 10:07 José María Alonso
2015-09-07 12:33 Andrey Grozin
2015-08-29 11:24 Andrey Grozin
2015-08-27 21:14 José María Alonso
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=1454871510.944c46edbf96fffc7d9151853ba361589d6a13d0.idella4@gentoo \
--to=idella4@gentoo.org \
--cc=gentoo-commits@lists.gentoo.org \
--cc=gentoo-dev@lists.gentoo.org \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox